#ifndef MESSAGE_H
#define MESSAGE_H
#include <time.h>

struct Deliveries {
  Deliveries *next;
  unsigned long msgnr;
  char *recipient;
  struct tm *zeitpunkt;
  unsigned long dnr;
  unsigned char *servermessage;
  unsigned char *state;
  bool tolocal;
  int local,remote,maxlocal,maxremote;
};

struct Message {
  Message *next;
  Message *last;
  char *sender;
  char *recipient;
  struct tm *startzeit;
  struct tm *endzeit;
  unsigned long msgnr;
  unsigned long bytes;
  bool endmsg;
  bool fromlocal;
  Deliveries *deliveries;
};

class MHandler {
  protected:
    Message *new_message ();
    Deliveries *new_deliverie ();
    Message *getmessage (unsigned long msgnr);
    Deliveries *getdeliverie (unsigned long dnr);
    Deliveries *aktdeliverie;	// auf diesen beziehen sich die status nachrichten

    
  private:
    Message *lmessage;	// Die letzte Message die gesichert wurde
    
  public:
    Message *mWurzel;
    char *loguser;
    
    MHandler ();
    ~MHandler();
    
    int deliveriestatus (int local,int maxlocal,int remote,int maxremote);
    int newdeliverie (unsigned long dnr,unsigned long msgnr,char *recipient,char *localremote,struct tm *datum);
    int deliveriestate (unsigned long dnr,char *dstate,char *servermessage,struct tm *datum);
    int endmessage (unsigned long msgnr, struct tm *datum);
    int infomessage(unsigned long msgnr,unsigned long bytes,char *sender,struct tm *datum);
    Message *newmessage(unsigned long msnr,struct tm *datum);
};

#endif
