#ifndef PARSER
#define PARSER
#include <stdio.h>
#include "message.h"
#include "results.h"
#include "graphs.h"
#include "xmlinput.h"
#include "data.h"

struct FileBuffer {
  FileBuffer *nextline;
  char line[256];
};

class Parser {
  protected:
    struct dirent *logdir;
    LogFiles *LogWurzel; 
    int parsefile (LogFiles *file);
    void saveresults ();
    bool Processed (char *name);
    
  public:
    MHandler *messages;
    Results *results;
    Images *images;
    Config *config;
    XMLInput *xmlinput;
    XMLOutput *xmloutput;
    Parser ();
    ~Parser ();

    void freefiles();
    int start();
    int logfiles ();
    int save();
};

#endif
